'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LayoutMediaQueryFactory = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _helpers = require('./helpers');

var _breakpoints = require('./breakpoints');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LayoutMediaQueryFactory = function LayoutMediaQueryFactory(BREAKPOINTS) {
  var _class, _temp2;

  return _temp2 = _class = function (_Component) {
    (0, _inherits3.default)(_class, _Component);

    function _class() {
      var _ref;

      var _temp, _this, _ret;

      (0, _classCallCheck3.default)(this, _class);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = _class.__proto__ || (0, _getPrototypeOf2.default)(_class)).call.apply(_ref, [this].concat(args))), _this), _this.containerRef = (0, _react.createRef)(), _this.state = {
        params: _this.props.initialMediaQueries
      }, _this.containerResizeObserver = null, _this.matchQueries = (0, _helpers.matchQueries)(BREAKPOINTS), _this.handleWindowResize = function (e) {
        var width = e.target.outerWidth;
        var params = _this.state.params;

        var result = _this.matchQueries(width);
        if (!(0, _shallowequal2.default)(result, params)) _this.setState({ params: result });
      }, _this.handleContainerResize = function (entries) {
        var target = entries[0].target;
        var width = (0, _helpers.getWidth)(target);
        var params = _this.state.params;

        var result = _this.matchQueries(width);
        if (!(0, _shallowequal2.default)(result, params)) _this.setState({ params: result });
      }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var viewport = this.props.viewport; // eslint-disable-line react/prop-types

        var container = this.containerRef.current;
        var initialWidth = 0;

        if (viewport) {
          window.addEventListener('resize', this.handleWindowResize);
          initialWidth = window.outerWidth;
        } else {
          this.containerResizeObserver = new _resizeObserverPolyfill2.default(this.handleContainerResize);
          this.containerResizeObserver.observe(container);
          initialWidth = (0, _helpers.getWidth)(container);
        }

        var result = this.matchQueries(initialWidth);
        this.setState({ params: result });
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.containerResizeObserver && this.containerResizeObserver.disconnect();
        this.containerResizeObserver = null;
        window.removeEventListener('resize', this.handleResize);
      }
    }, {
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate(_, nextState) {
        return !(0, _shallowequal2.default)(this.state.params, nextState.params);
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(
          'div',
          { className: 'sui-Layout-MediaQuery', ref: this.containerRef },
          this.props.children(this.state.params)
        );
      }
    }]);
    return _class;
  }(_react.Component), _class.defaultProps = {
    initialMediaQueries: {}
  }, _class.propTypes = {
    /**
     * MediaQueries to be used in the first render until componentDidMount is called and it setups the proper media query. Useful for SSR for avoiding re-renders.
     */
    initialMediaQueries: _propTypes2.default.object,
    children: _propTypes2.default.func
  }, _temp2;
};

var LayoutMediaQuery = LayoutMediaQueryFactory(_breakpoints.BREAKPOINTS);
LayoutMediaQuery.displayName = 'LayoutMediaQuery';

LayoutMediaQuery.propTypes = {
  /** Wether to listen to the viewport resize or not (it listens to the container resize by default) */
  viewport: _propTypes2.default.bool
};

exports.default = LayoutMediaQuery;
exports.LayoutMediaQueryFactory = LayoutMediaQueryFactory;